# gdcm::Dict Class Reference

Class to represent a map of DictEntry. More...

`#include <gdcmDict.h>`

Collaboration diagram for gdcm::Dict:
[legend]

List of all members.

## Public Types

typedef MapDictEntry::const_iterator | ConstIterator
typedef MapDictEntry::iterator | Iterator
typedef std::map< Tag, DictEntry > | MapDictEntry

## Public Member Functions

| Dict ()
void | AddDictEntry (const Tag &tag, const DictEntry &de)
ConstIterator | Begin () const
ConstIterator | End () const
const DictEntry & | GetDictEntry (const Tag &tag) const
const DictEntry & | GetDictEntryByKeyword (const char *keyword, Tag &tag) const
const DictEntry & | GetDictEntryByName (const char *name, Tag &tag) const
const char * | GetKeywordFromTag (Tag const &tag) const
| Function to return the Keyword from a Tag.
bool | IsEmpty () const

## Protected Member Functions

void | LoadDefault ()

## Friends

class | Dicts
std::ostream & | operator<< (std::ostream &_os, const Dict &_val)

## Detailed Description

Class to represent a map of DictEntry.

Note:
  bla TODO FIXME: For Element == 0x0 need to return Name = Group Length ValueRepresentation = UL ValueMultiplicity = 1

Examples:

  GenAllVR.cxx, GenFakeIdentifyFile.cxx, PublicDict.cxx, and ReadAndPrintAttributes.cxx.

## Member Typedef Documentation

typedef MapDictEntry::const_iterator gdcm::Dict::ConstIterator

typedef MapDictEntry::iterator gdcm::Dict::Iterator

typedef std::map<Tag, DictEntry> gdcm::Dict::MapDictEntry

## Constructor & Destructor Documentation

gdcm::Dict::Dict | ( |  | ) | `[inline]`

## Member Function Documentation

void gdcm::Dict::AddDictEntry | ( | const Tag & | tag,
|  | const DictEntry & | de
| ) |  | `[inline]`

ConstIterator gdcm::Dict::Begin | ( |  | ) | const`[inline]`

Examples:
  GenAllVR.cxx, and GenFakeIdentifyFile.cxx.

ConstIterator gdcm::Dict::End | ( |  | ) | const`[inline]`

Examples:
  GenAllVR.cxx, and GenFakeIdentifyFile.cxx.

const DictEntry& gdcm::Dict::GetDictEntry | ( | const Tag & | tag | ) | const`[inline]`

Examples:
  GenFakeIdentifyFile.cxx, and PublicDict.cxx.

const DictEntry& gdcm::Dict::GetDictEntryByKeyword | ( | const char * | keyword,
|  | Tag & | tag
| ) |  | const`[inline]`

Lookup DictEntry by keyword. Even if DICOM standard defines keyword as being unique. The lookup table is built on Tag. Therefore looking up a DictEntry by Keyword is more inefficient than looking up by Tag.

const DictEntry& gdcm::Dict::GetDictEntryByName | ( | const char * | name,
|  | Tag & | tag
| ) |  | const`[inline]`

Inefficient way of looking up tag by name. Technically DICOM does not garantee uniqueness (and Curve / Overlay are there to prove it). But most of the time name is in fact uniq and can be uniquely link to a tag

Examples:
  ReadAndPrintAttributes.cxx.

const char* gdcm::Dict::GetKeywordFromTag | ( | Tag const & | tag | ) | const`[inline]`

Function to return the Keyword from a Tag.

bool gdcm::Dict::IsEmpty | ( |  | ) | const`[inline]`

Referenced by gdcm::Dicts::IsEmpty().

void gdcm::Dict::LoadDefault | ( |  | ) | `[protected]`

## Friends And Related Function Documentation

friend class Dicts `[friend]`

std::ostream& operator<< | ( | std::ostream & | _os,
|  | const Dict & | _val
| ) |  | `[friend]`

The documentation for this class was generated from the following file:

- gdcmDict.h